#include "fivewin.ch"

STATIC c_path, c_path1

FUNCTION MAIN()
LOCAL oDlg, oBtn1, oFont1, oFont2, oSay1

SETBALLOON( .T. ) 

c_path := cFilePath(GetModuleFileName( GetInstance() ) )
c_path1 := c_Path + "SYSTEM\"

DEFINE FONT oFont1 NAME "ARIAL" SIZE 0,-12 BOLD
DEFINE FONT oFont2 NAME "ARIAL" SIZE 0,-46 BOLD

DEFINE DIALOG oDlg RESOURCE "TEST"  PIXEL ; 
FONT  oFont1 TITLE "GRADIENT-test"  

REDEFINE SAY oSay1 PROMPT "TRANSPARENT-test"  ID 110 OF oDlg  FONT oFont2		  
oSay1:Setcolor( 255,  )
oSay1:lTransparent := .T.

REDEFINE BTNBMP oBtn1 OF oDlg ;
ID 70 PIXEL 2007 ;
NOBORDER ;
PROMPT " &Exit " ;
FILENAME c_path1 + "Exit.Bmp" ;
ACTION oDlg:End() ;
FONT oFont1 ;
LEFT
oBtn1:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 6711039, 16777215 }, ;
		{ 0.50, 16777215, 6711039 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oBtn1:lTransparent := .t.   
oBtn1:cToolTip =  { "Exit" + CRLF + "Gradient-test","EXIT", 1, CLR_BLACK, 14089979 }
oBtn1:SetColor( 0, )

ACTIVATE DIALOG oDlg CENTER ;
ON INIT WD_BACKGRD( oDlg, 16745090, 10790143, 16777215, 0.5, .T. )
 
RETURN( NIL )
 
// --------  DIALOG - Background ---------------
 
FUNCTION WD_BACKGRD( oWnd, nDColor1, nDColor2, nDColor3, nDGradpos, lDDirect )
Local hDC, oBrush, aGrad
 
aGrad := { { nDGradpos, nDColor1, nDColor2 }, { nDGradpos, nDColor2, nDColor3 } }
hDC = CREATECOMPATIBLEDC( oWnd:GetDC() )
hBmp = CREATECOMPATIBLEBITMAP( oWnd:hDC, oWnd:nWidth(), oWnd:nHeight() )
hBmpOld = SELECTOBJECT( hDC, hBmp )
GRADIENTFILL( hDC, 0, 0, oWnd:nHeight(), oWnd:nWidth(), aGrad, lDDirect ) // .T: = Vertical
oBrush = TBrush():New( ,,,, hBmp )
oWnd:SetBrush( oBrush )
AEVAL( oWnd:aControls, { | oCtl | IF( oCtl:lTransparent, oCtl:SetBrush( oWnd:oBrush ), ) } )
SELECTOBJECT( hDC, hBmpOld )
DELETEDC( hDC )
oWnd:ReleaseDC()
 
RELEASE BRUSH oBrush
 
RETURN( NIL )